%{
#include <stdio.h>
#ifdef VMS
#include <ssdef.h>
#else
#define SS$_NORMAL 1
#endif

void	print_help(),check_char();
void	comment();

char	VERSION[]="V1.1";
char	UPDATED[]="11-May-1999";


char	*PRT_OPEN[3]={" printf("," print "," cout << "};
char	*PRT_CLOSE[3]={")","",""};

int	num_char=0;
int     LENGTH=60;
short int mode=0;
short int FIRST=1;


#define YY_USER_ACTION	if(FIRST){comment();}



%}



%%
\t			fprintf(yyout,"\\t");check_char(2);
\n|(\015|\015\012)\n	fprintf(yyout,"\\n");check_char(2);
\010			fprintf(yyout,"\\b");check_char(2);
\015			fprintf(yyout,"\\r");check_char(2);
\014			fprintf(yyout,"\\f");check_char(2);
"$"|"@"			if(mode==1){
				fprintf(yyout,"\\%s",yytext);
				check_char(2);
			} else {
				fprintf(yyout,yytext);
				check_char(1);
			}
"%"			fprintf(yyout,"%%%%");check_char(2);
\134|\042		fprintf(yyout,"\\%s",yytext);check_char(2);
.			fprintf(yyout,yytext);check_char(1);
<<EOF>>			fprintf(yyout,"\"%s;",PRT_CLOSE[mode]); yyterminate();
%%


int main(int argc,char **argv )
{
int i;

 for(i=1 ; i < argc ; i++){
	if(strcmp(argv[i],"-h") == 0)		print_help(argv);
	else if(strcmp(argv[i],"-p") == 0)	mode = 1;
	else if(strcmp(argv[i],"-x") == 0)	mode = 2;
	else if(strcmp(argv[i],"-l") == 0)	LENGTH = atoi(argv[++i]);
	else {
	 	if( ! yyin ) yyin = fopen( argv[i], "r" );
		else yyout = fopen( argv[i], "w" );
	}
 }

 yylex();

}



void comment()
{
 if(yyout != stdout){
	fprintf(yyout,"  %s Formatted by text2c %s (Flex V%d.%d). Last update %s %s\n",
  		(mode==1?"#":"/*"),
		VERSION,YY_FLEX_MAJOR_VERSION,YY_FLEX_MINOR_VERSION,UPDATED,
		(mode==1?"":"*/"));
 }
 fprintf(yyout," %s\"",PRT_OPEN[mode]);
 FIRST = !FIRST;
}


void check_char(int n)
{
 num_char += n;
 if(num_char >= LENGTH){
 	fprintf(yyout,"\"%s;\n %s\"",PRT_CLOSE[mode],PRT_OPEN[mode]);
	num_char	= 0;
 }
}



void print_help(char **argv)
{
char    *p_nom                  ;

#ifdef VMS
 p_nom   = strrchr(argv[0], ']');
#else
 p_nom   = strrchr(argv[0], '/');
#endif
 p_nom   = &p_nom[1];
 printf("\nTEXT2C version %s. Copyright (C) 1998-1999 Jrme LAURET\n\n",VERSION);
 printf("This is a txt2c filter that converts  a regular text file into print\n");
 printf("statements  to be  included into your C,  C++ or perl  programs. The \n");
 printf("default is to output C printf() statements.\n");
 printf("\nUsage is : $ %s [options] [InputFile] [OutputFile]\n",p_nom);
 printf("Options are : \n");
 printf("   -h     shows this help\n");
 printf("   -p     perl print statements\n");
 printf("   -x     C++ cout statements\n");
 printf("   -l x   output 'x' characters per line.\n\n");
 printf("If you have any  suggestions, comments, or updates to this  utility,\n");
 printf("please Email me at jlauret@mail.chem.sunysb.edu.\n\n");
 exit(SS$_NORMAL);
}

